/*
TelnetPort.h

Telnet Communication made to look like Serial I/O functions
*/

#pragma once

#include "Xpert/Win32Fix.h"
#include "TcpPort.h"
#include "Socket.h"

#undef DECL
#if defined(NOT_XPERT)
#define DECL
#else
#if defined(_AFXDLL) || defined(XPERT_EXE)
#ifdef UTILS_DLL
#define DECL _declspec(dllexport)
#else
#define DECL _declspec(dllimport)
#endif
#else
#define DECL 
#endif
#endif

class DECL CTelnetPort : public CTcpPort
{
public:
   CTelnetPort(TSocket& aSocket);
   ~CTelnetPort();

   // open/close
   bool CloseComm();
   bool OpenComm();

   // data
   int Get(void* Buffer, int BufferLen, DWORD dwTimeout);
   bool Put(const void* Buffer, int BufferLen, DWORD dwTimeout);

   int  NumberBytesInputBuffer(); // returns number of bytes in input buffer
   void FlushInput();             // empties rx buffer
   BOOL WaitCommEvent(LPDWORD lpEvtMask);

   void SetTelnetMode()        { TelnetDetected = true; RawMode = false; };
   void SetRawMode()           { TelnetDetected = false; RawMode = true; };
   void SetNegotiate(bool On)  { DoNegotiate = On; };
   bool IsTelnet()             { return TelnetDetected; };

protected:
   void ProcessBuffer(int Len=0, DWORD dwTimeout=0);
   UCHAR InputBuffer[4096];
   int InputLen;
   int InputPos;
   int Stranded;
   bool TelnetDetected;
   bool RawMode;
   bool DoNegotiate;
};
